#include "pvtbl.h"


struct pvtNode *pv_table = 0, *pv_game_table = 0;


void pvt_push_first( struct pvtNode **root, Move *line)
{
   struct pvtNode *p = *root;
     
   *root = (struct pvtNode*)malloc( sizeof(struct pvtNode) );    // ADD NEW NODE
   
   (*root)->line = line;
   
   (*root)->next = p;

}


void pvt_push_last( struct pvtNode **root, Move *line)
{
   while( *root )
     root = &(*root)->next;                     // GO TO END
     
     
   *root = (struct pvtNode*)malloc( sizeof(struct pvtNode) );    // ADD NEW NODE
   
   (*root)->line = line;
   
   (*root)->next = 0;
   

}



Move  *pvt_pop_first( struct pvtNode **root)
{
   struct pvtNode *p = *root;     // save first
   Move *line = 0;
   
   if(p){                         // remove first
   
     line  = p->line;
     *root = p->next;
     
     free( p );
   }
     
     
   return line;

}



void pvt_clear_all( struct pvtNode **root )
{
   
   while(*root)
   {
      struct pvtNode *tmp = *root;
      
      *root = tmp->next;
      
      free(tmp);
   
   }
   
       
}



void  pvt_for_each(  struct pvtNode **root, void (*handler)(Move *line) )
{

   while(*root)
   {
   
      handler( (*root)->line );
      
      root = &(*root)->next;
   
   }


}





Move *LineCopy (Move *dest, Move *src)
{
  Move *p = dest;

  loop:
    *dest = *src;
    if( *dest ) {
      dest++;
      src++;
      goto loop;
    }

  return p; 
}


int   LineLen  (Move *line)
{
  int len = 0;
  
  while(*line)
  {
    len++;
    line++;
  }

  return len;
}


Move *LineDup  (Move *line)
{
  
  return LineCopy( (Move*)malloc( (LineLen(line)+1) * sizeof(Move)),
                   line );


}


void  LinePrint (Move *line)
{
   while( *line )
   {
     char buf[32];
     
     printf( "%s ", MoveToStr(*line, buf));
     
     line++;
   }
   printf("\n");
   
   
   /****************
   char buf[32];
   int j;
   
   
     for(j = 0; j < 20 && line[j]; j++)
       printf("%s ", MoveToStr( line[j], buf));  
   
          
   printf("\n");    
   *************/
}


void LineFree( Move *line )
{
  if(line)
  {
    free(line);
   
  }
}




int   LineInCnt    (Move *line, Move *sub_line) /* return cnt in */
{
    int cnt = 0;
    
    while(*sub_line==*line  &&  *sub_line != 0)
    {
      sub_line++;
      line++;
      cnt++;
    }

    return cnt;

}













/*****************************************************************
#define MAX_MOVES  (MAX_GAME + MAX_PLY)
#define MAX_LINES  256


struct pvtLine{

  Move line[MAX_MOVES];
  int cnt;

  int id;
};

struct pvtTable{
  
  struct pvtLine lines[MAX_LINES];
  int cnt;
  
} table;



pvt_clear()
{
  table.cnt = 0;
}

pvt_push( Move *line )
{
  struct pvtLine *p = &table.lines[table.cnt % MAX_LINES];
  
  
  p->id = table.cnt;
  table.cnt++;


   
  for(p->cnt = 0;  
  
      p->cnt < MAX_MOVES      &&
      ( (p->line[p->cnt] = line[p->cnt]) != 0 );
      
      p->cnt++)      
  {
  
  }

  return 0;
}


Move *pvt_pop()
{
  if(table.cnt > 0)
    return table.lines[(--table.cnt) % MAX_LINES].line;
  else  
    return 0;

}


int pvt_get_cnt(){

  return table.cnt;
  
}



pvt_print()
{
  int j,k;
  
  for(j = MAX_LINES-1; j >= 0; j--)
  {
    struct pvtLine *p = &table.lines[j];
    
    if(p->id != -1)
    {
       char buf[32];
       
       if(table.cnt > 0)
        if( ((table.cnt-1) & MAX_LINES) == j )
          printf("----> ");

       
       printf("%3d  id=%3d  ",  j,  p->id);
       
       
       for(k = 0; k < p->cnt; k++)
         printf("%s ", MoveToStr( p->line[k], buf ));
    
       printf("\n");
    }
  
  }  

}
****************/




