#ifndef pvtable_h
#define pvtable_h


#include "chess.h"


#define PVT


struct pvtNode{
  
   Move *line;
   
   struct pvtNode *next;
};



Move *LineCopy  (Move *dest, Move *src);
int   LineLen   (Move *line);
Move *LineDup   (Move *line);
void  LinePrint (Move *line);
int   LineInCnt (Move *line, Move *sub_line); /* return cnt in */
void  LineFree  (Move *line );


void   pvt_clear_all( struct pvtNode **root );
void   pvt_push_first(struct pvtNode **root, Move *line);
void   pvt_push_last( struct pvtNode **root, Move *line);
Move  *pvt_pop_first( struct pvtNode **root);
void   pvt_for_each ( struct pvtNode **root, void (*handler)(Move *line) );


#define  pvt_print(root)   pvt_for_each((root), LinePrint)

extern struct pvtNode *pv_table, *pv_game_table;



#endif


