#include "chess.h"
#include "pvtree.h"


 
extern char *property_get(char*);
extern int search_tree_width_null_move_cut;
extern int root_side;
extern int s_depth, doNull,doReduction;
extern int history[2][8][64];// mate_history[2] [8] [64];
extern int root_mtl[2];
extern Line pv_line, killer, pv_killer, gl_find_move;
extern int cut_forse[MAX_PLY];
extern Move    search_mv;
extern int     search_score;
extern int     search_depth;
extern Move    search_list[MAX_GAME + MAX_PLY]; //0002
extern HashKey search_start_pos_key;
extern  PVTree *pv_tree;
extern int Check(void);
extern void HashClear(void);
extern void set_rep(void);
extern int LegalMoveList(void);
void PickMove(Move mv, int low, int high) ;


/*
  function int LegalMoveList(void);

  return 
        0 - cap.king (illegal move find)
        1 - success
  moves:
       tree[treeCnt[ply]] .. tree[treeCnt[ply+1]-1]

  count moves:
        treeCnt[ply+1] - treeCnt[ply]

  limits:

        extern  int treeCnt[MAX_PLY];
        extern  Move tree[MAX_PLY * 100];     
        extern  int  sort_val[MAX_PLY * 100];
*/

 




 int Rnd_Root_Search(Move *ret_move){
   int main_search( int alpha, int beta, int depth, int check,
                   Line ret_pv_line, int lazy , 
                   int isTree, int useNull,
                   Move in_move
                 );
   void init_search(void);
   int RndSearch(void);
   void PickMove(Move mv, int low, int high);
   int j,k;
   int find_score[10];
   int ret = 0;
   extern unsigned TICK_COUNT(void);
   time_t start_t__ = TICK_COUNT();

   extern time_t limit_time;
   time_t save_t = limit_time;
   int max_depth;
   static char buf[64];    

   int a,b,max_d,n;
   int sr_d=0,sr_score=0;
   Move sr_mv=0;

   void debug_print_moves_and_score(void);
  


   printf("search move ... \n");


   treeCnt[0] = 0;
   //init
   *ret_move = 0;
   init_search();
   srand(time(0));


 //---------  check moves without search ---------
   if(LegalMoveList()==0 ||
      treeCnt[1] == treeCnt[0] )   // not moves ?
   {
       printf("#cap. king - illegal move \n");    
       return 0;
   }
   if(treeCnt[1] == treeCnt[0]+1)  // one reply ?   
   {
       printf("# one reply \n");
       *ret_move = tree[treeCnt[0]];
       return 1;
   }

  if( strcmp( property_get("book move"), "auto") == 0 )
  do
  {
    Move mv;
    if( rand()%101  <= 50 )
      if ( ( mv = MoveFromLib( treeCnt[0], treeCnt[1] - 1 ) ) != 0 )
      {
          printf("# find move from open. book \n");
        *ret_move = search_mv = mv;
        return 1;
      }
  }while ( 0 );
 //------------------- end --------------------------





   //random moves (temp variant)
   for(j=treeCnt[0]; j < treeCnt[1]; j++)
      sort_val[j] = rand()%16;


 limit_time = save_t*50/100; TimeReset();  //<--------------
 //find best score
 a = -INF; b = INF;

 printf("#------> stage1 - search best move, time = %02f \n", (double)limit_time/100); 

 for(s_depth = 2; s_depth < 40 && !StopSearch(); s_depth++)
 {
    
    int  score = main_search(a,                    // ROOT_SEARCH
                            b, 
                            s_depth, Check(),
                            pv_line, 0 , 0, 0,
                            search_mv//in_move
                           );


    /***
    if(!StopSearch())
     if(score <= a || score >= b)
        score = main_search(-INF,  // ROOT_SEARCH
                           INF, 
                           s_depth, Check(),
                           pv_line, 0 , 0, 0,
                           search_mv//in_move
                           );
   */
    if(search_depth == s_depth)//      
    {
       sr_score = search_score;
       sr_mv    = search_mv;
       sr_d     = search_depth;
    }
     
  //  a = score - 30; if(a < -INF) a = -INF;
  //  b = score + 30; if(b > INF)  b = INF;
  //  if(b <= 0) b = 0+1;

 }

 //??
 //debug_print_moves_and_score();


 limit_time = save_t*90/100; TimeReset();  //<------------
 // search moves - kandidate
 a = sr_score-2*VALUE_P;//sr_score-VALUE_P; //sr_score;
 b = INF;//sr_score+1; //sr_score + 1;
 if(a < -INF) a = -INF;
 if(b > INF) b = INF;
 //if(sr_d & 1) 
 max_depth = sr_d;
 //else max_depth = sr_d+1;


//exclude best move 
 PickMove(sr_mv, treeCnt[0], treeCnt[1]-1);
 sort_val[0] = sr_score;
 treeCnt[0] = 1;


 printf("#----> find best move %s,    score %d, depth %d\n",
         MoveToStr(sr_mv,buf), sr_score, sr_d ); 

 MoveToStr(tree[0],buf);

 if(sr_score > INF-100)  // FIND MATE?
 {
    *ret_move = tree[0];
    ret = 1;
    goto done;
 }

  printf("#----> search kandidate's moves ...  time = %02f \n", (double)limit_time/100);


for(n = 0; 
    n < 1 && !StopSearch() && treeCnt[1] > treeCnt[0]; 
    n++)
{
 void HashDepthLow(void);

 HashDepthLow();

 for(s_depth = 2; 
     s_depth <= max_depth && !StopSearch(); 
     s_depth++)
 {
    
    int  score = main_search(a,                    // ROOT_SEARCH
                            b, 
                            s_depth, Check(),
                            pv_line, 0 , 0, 0,
                            search_mv//in_move
                           );
   
  if(search_depth >= max_depth)
    if(score > a)
     {                      //exclude best move
      PickMove(search_mv, treeCnt[0], treeCnt[1]-1);
      sort_val[treeCnt[0]] = search_score;
      treeCnt[0]++;

       printf("#----> find kandidat move %s, score %d, depth %d\n",
              MoveToStr(search_mv,buf), score, max_depth ); 


     }else goto skip1; //    
 }

 //---------

}//for n

skip1:

 


 if(treeCnt[0]==1)  // find 1 legal move 
 {
     printf("# find search. one move only \n");
    *ret_move = tree[0];
    ret = 1;
    goto done;

 }

 //  add random score for all legal moves 

   limit_time = save_t*10/100; TimeReset();    //<-------------
   treeCnt[1] = treeCnt[0];
   treeCnt[0] = 0;

   /***
   -      
   
       
    ,  random   
     
   ***/

   if(sort_val[0] > sort_val[1] || //   -      
      sort_val[1] > sort_val[0] + 5 ) //        ,  random     
   {
       printf("#skip random score (result undefined) \n");
       Pick(0, treeCnt[1]-1);

       *ret_move = tree[0];
       ret = 1;
       goto done;
   }


  // for(k = treeCnt[0]; k < treeCnt[1]; k++)
  //     sort_val[k] = -INF; //clear

   printf("#-----> stage2: assign additional random score,  time = %02f \n", (double)limit_time/100);


   while(!StopSearch())
   {
     for(j = treeCnt[0]; j < treeCnt[1]; j++)
     {

       MakeMove(tree[j]);
       if(!StopSearch())
         sort_val[j] += -RndSearch();
       UnMakeMove(tree[j]);
       if(sort_val[j] > INT_MAX-2)
           goto skip;
       if(sort_val[j] < INT_MIN+2)
           goto skip;
     }
   }
skip:

   printf("# ----> result of search \n");
   for(k = treeCnt[0]; k < treeCnt[1]; k++)  //sort moves
   {
     Pick(k, treeCnt[1]-1);
     printf("#move %s, score %d\n", MoveToStr(tree[k],buf), sort_val[k]);
   }
   *ret_move = search_mv = tree[treeCnt[0]];
   ret = *ret_move != 0;  
done:

   if(*ret_move){
      void SaveSearchResult(int,int); 

      printf("# select move: %s, %d \n", 
              MoveToStr(*ret_move,buf),
              sort_val[0]);
      SaveSearchResult( sort_val[0], sr_d );

   }else printf("# move not fond ?!! \n");

    limit_time = save_t;
    treeCnt[0] = 0;


    printf("#search time %02f \n", (double)(TICK_COUNT()-start_t__)/100 );


    return ret;
 }//endp
 //--------------------------------



 void debug_print_moves_and_score(void){
   int j;
   char buf[64];

   for(j = treeCnt[0]; j < treeCnt[1]; j++)
      printf("(%d) %s <%d>; ", j, MoveToStr(tree[j],buf),
             sort_val[j] );
   printf("\n");

 }





 //--------------
 int RndSearch(void){
    int i, cnt_moves, score;
    Move mv;
    int Check(void);

     if(StopSearch()) return 0;
     if(ply > MAX_PLY-4) return 0; // out moves buffer 

     if(LegalMoveList()==0) return 0; // ?cap. king
     cnt_moves = treeCnt[ply+1] - treeCnt[ply];
     if(cnt_moves == 0)
     {
        if(Check()) return -1; //mate
        return 0; 
     }
     if(cnt_moves==1) i = 0;
     else i = rand() % cnt_moves;

     mv = tree[treeCnt[ply] + i];
     MakeMove(mv);
     score = -RndSearch();
     UnMakeMove(mv);

     return score;


 }
 //--------------

 void PickMove(Move mv, int low, int high){
     int j, max_i = low;

     for(j = low; j <= high; j++)
         if(mv == tree[j])
         {
            
            max_i = j;
         }
      if(max_i > low)
      {
        int tmp = tree[max_i];
        tree[max_i] = tree[low];
        tree[low] = tmp;

        tmp = sort_val[max_i];
        sort_val[max_i] = sort_val[low];
        sort_val[low] = tmp;


      }

 }


 //--------------
 void init_search(void){



  treeCnt[0] = 0;
  srand( time( 0 ) );
  set_dir(g.side);
  TimeReset();
  InitEvaluate();
  HashClear();
  set_rep();
  HistoryInit( 1 );
  if( pv_tree == NULL ) pv_tree = (PVTree*)malloc(sizeof(PVTree));

  pvReset( pv_tree );
  
  memset( killer, 0, sizeof( killer ) );
  memset( pv_killer, 0, sizeof( pv_killer ) );
  memset(pv_line,0,sizeof(Line));
  memset(sort_val,0,sizeof(sort_val));

  root_side = g.side;
  root_mtl[WHITE] = g.mtl[WHITE];
  root_mtl[BLACK] = g.mtl[BLACK];
  
  search_mv    = 0;
  search_score = 0;
  search_depth = 0;

  search_tree_width_null_move_cut = g.cnt[WHITE][QUEEN] && g.cnt[BLACK][QUEEN];
  
 }


