
#include "chess.h"
#include "pvtree.h"
#include "pvtbl.h"


//------------
#define MIN_KNOWLEDGE1


//int old_search_result[2];

int Check();

//------------------------------------------------
                                       // play style 

extern char* property_get(char name[]);


#define KNOWLEDGE1 0   // search(bruit force) + 1 PLY in main search     //check mate only  
#define KNOWLEDGE2 1   // search(LMR+Sing) + main_search(search+sing)
#define KNOWLEDGE3 2   // search(LMR+ Sing.material) + main_search(search)


#define SING_IN_SEL_SEARCH  1 //  (PLAY_STYLE >= ATTACK_SINGULAR && PLAY_STYLE != TMP)


int repetition_set[REP_SET_SIZE];

char *play_style_str[] = {
  "knowledge1", "knowledge2", "knowledge3", NULL
};



int PLAY_STYLE = KNOWLEDGE3;
int is_rnd_search = 0;


char* print_play_str(void){

  return play_style_str[PLAY_STYLE];
}

//property_get("play style");
int load_play_style(char s[]){

  int j;
  static int first = 1;
  
  if(!s) return 0;

  for(j = 0; play_style_str[j]; j++)
   if(strcmp(s, play_style_str[j]) == 0)
   {
      PLAY_STYLE = j;
     
    //  if(first)
    //  {
    //    printf("# style = %s \n", play_style_str[j]);
    //    first = 0; 
    //  }

      return 1;
   }
  

  //fprintf( stderr, "# error: play style unknow \n" );
  //fprintf( stderr, "#        use default play style - <%s> \n", play_style_str[PLAY_STYLE]);
  
  return 0;

}
//---------------------------------------------------------

//-------------------------
 /*
      
        
 */
 void set_rep(void){

  int j;

  return ;


  memset(repetition_set, 0, sizeof(repetition_set));
  //int repetition_set[REP_SET_SIZE];
  
  repetition_set[g.start_pos_key & (REP_SET_SIZE-1)]++ ;

  for(j = 0; j < g.game_cnt; j++)
  {
      repetition_set[g.key_list[j] & (REP_SET_SIZE-1)]++;
  }
  
  g.empty_moves_cnt = 0;
  for(j = g.game_cnt-1; j >= 0; j--)
  {
      Move mv = g.game_list[j];
      if( (mv & (CAPTURE|PROMOTE|LEFT_CASTL|RIGHT_CASTL)) || 
           mv == 0 || 
          PIECE((mv)) == PAWN)
          break;
      else
          g.empty_moves_cnt++;  

  }
     

 }

 //---------------------------------






#define PV (vtr.moveFromTree && legalCnt <= 3)
#define MAIN_PV (vtr.moveFromTree && legalCnt ==1 && alpha==-INF && beta==INF)
#define MTL(c)  (g.mtl[c] - g.mtl[c^1])
#define ROOT_MTL(c)  (root_mtl[c] - root_mtl[c^1])


const int MAX_HIST = 32000;


/*  for NextMove function, save status of get moves  */
typedef struct
{
  int phase, low, high, sort, * alpha, moveFromTree, isTree;
  Move hash_mv, pv_mv, kill_mv, pvkill_pv;
  int cut,cutCnt;
  PVNode *list_pv;
  int cntBestKillers; 
  
  Move in_move;

}PhaseInfo;


int tree_is_good(PhaseInfo *vtr, int legal_cnt){

    return vtr->moveFromTree;
    //return legal_cnt <= 3 && vtr->moveFromTree;
}




// int search_tree_width_reductions_2 = 1;
int search_tree_width_null_move_cut = 1;






Move    search_mv;
int     search_score;
int     search_depth;
Move    search_list[MAX_GAME + MAX_PLY]; //0002
HashKey search_start_pos_key;



int root_side;
int s_depth, doNull,doReduction;
int history[2][8][64];// mate_history[2] [8] [64];
int root_mtl[2];
Line pv_line, killer, pv_killer, gl_find_move;
int cut_forse[MAX_PLY];

 PVTree *pv_tree;  // in pvtree.c



extern int __foo; //  debug

/* in timer.c */
extern time_t start_time, curr_time, limit_time;
extern int is_stop_search;
extern U64 cnt_nodes;




//--------------------------------------------------------

void PhaseInfoReset( PhaseInfo * p, int * alpha )
{
  p->phase = p->low = p->high = p->sort = p->moveFromTree = p->isTree = 0;
  p->hash_mv = p->pv_mv = p->kill_mv = p->pvkill_pv = 0;
  p->list_pv = 0;
  p->alpha = alpha;
  p->cut = p->cutCnt = p->cntBestKillers = p->in_move = 0;
}



/*  recursive alpha-beta search  */

int Search( int alpha, int beta, int depth, int check,
            Line ret_pv_line, int lazy , int isTree, int useNull, 
            Move in_move, Move exclude_move
          )
{
  int Quies( int alpha, int beta );
  int StopSearch( void );
  int Evaluate( int alpha, int beta );
  int HashLook( int alpha, int beta, int depth, int * ret_score, Move * ret_mv );
  void HashInsert( int alpha, int beta, int depth, Move mv );
  int NextMove( PhaseInfo * p, Move * mv );
  int Check( void );
  void SaveHist( Move mv, int alpha, int beta );
  void SavePvLine( Line dest, Line source, Move mv );
  Move LastMove( void );
  int Repetition( void );
  int LegalCastl( Move mv );
  void SaveRootScore( int alpha, int beta, Move mv, int depth, Line line );
  int LearnLook( int depth, int alpha, int beta, int * ret_score );
  
  int score;
  Move mv = 0, best_mv = 0;
  PhaseInfo vtr;
  Line tmp_line;
  int c0 = g.side, c1 = c0 ^ 1;
  int old_alpha = alpha;
  int L_MTL = MTL(c0);
  int oneReply = 0;
//  int cut_cnt; 


  cut_forse[ply] = 0;



  //??
  /***
  if(alpha==-INF && beta==INF && s_depth==8)
  {
     char buf[32];

     printf("--(ply=%d, d=%d) %s \n", ply, depth, (char*)MoveToStr(LastMove(), buf));
  }
  ***/





  if(ply > 0)
  {

   if(check){
      int LegalMoveList(void);
      if ( LegalMoveList() == 0 ){
         return INF - ply; //CAP. OP. KING     //0x search return
         
      }
      else if ( treeCnt[ply + 1] == treeCnt[ply] ){
      
           cut_forse[ply] = 3;
           return -INF + ply + 1; // mate    //0x search return
      }
      else if ( treeCnt[ply + 1] == treeCnt[ply] + 1 ) oneReply = 1;
   }else{
     /****
      if ( Generate() == 0 ) return INF - ply; //CAP. OP. KING
      else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy
     *****/
   }

  }


  if( check ){
    if(depth <= 0) depth = 1;
    
  }else if( ply > s_depth * 3 )
    depth = 0;


  //0003
  PhaseInfoReset( & vtr, & alpha );
  vtr.isTree = isTree;
  vtr.in_move = in_move;

  

  if ( depth <= 0 ) return Quies( alpha, beta ); //0x search return
  if ( StopSearch() ) return 0;
  if ( ply > MAX_PLY - 4 ) return Evaluate( alpha, beta );
  if ( ply > 0 && Repetition() ){
  
          cut_forse[ply] = 4;
	  if(g.side==root_side)
		  return -8;
	  return 0;
  } 
  if ( ply > 4 && //!doNull  //000x1
       LearnLook( depth, alpha, beta, &score ) ) 
     return score;
     

  vtr.hash_mv = 0;     
  if ( HashLook( alpha, beta, depth, &score, &vtr.hash_mv ) )
  {
  //0002
     if(!isTree) 
      if(exclude_move==0){
      
        if(vtr.hash_mv)
          gl_find_move[ply] = vtr.hash_mv; // find move ?!
        cut_forse[ply] = 2;
        return score;
      }
  }   
  
  
  if(1)    //  
  {
    int legalCnt = 0;
    int cntGoodMoves;
    Move last = LastMove();
    int mateThreat = 0;
    //int oneReply = 0;

  //  int Search( int alpha, int beta, int depth, int check,
  //          Line ret_pv_line, int lazy , int isTree, int useNull)
	 
  // null-move cut-off
  if(useNull)// && !isTree) 
    if(  search_tree_width_null_move_cut && !lazy && !check && ply > 0 )
       do{
        int saveDoNull = doNull,tmp;

	 
	if(depth > 3)
	   if(Evaluate(beta-500-1, beta-500) < 	beta-500) 
	     break;
		  
        doNull = 1;
        treeCnt[ply + 1] = treeCnt[ply];
        MakeMove( 0 );
        tmp_line[ply] = 0;
        tmp = -Search( -(beta), -(beta-1), depth-3,
			         0, tmp_line, 1, 0, 0, 0, 0 );
        UnMakeMove( 0 );
        doNull = saveDoNull;
        if(tmp >= beta){
        
           cut_forse[ply] = 1;
           return beta;
           
        }
        if(  tmp < -INF+100 && beta > -INF+100)
          mateThreat = 1;
        
    }while(0);
skipNull:



if(ply > 0)
{
  if(!check)
  {
    if ( Generate() == 0 ) 
       return INF - ply;           //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) 
       return 0;                   // ?? not realy
  }

}else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy


/***
  IID
          ,
       depth/2
      
***/
if(depth >= 4) 
 if(( vtr.hash_mv | vtr.in_move)==0)
  if(ply > 0)
   // if(alpha+1 < beta)
 { 
   int is_move_from_tree=0;
   if(vtr.isTree)
    if( (doNull/*|doReduction*/)==0 )  // see in NextMove()
    {
          PVNode **tmp  = pvFindNodeTree(pv_tree, &g.game_list[g.game_cnt], ply);
          if(tmp && *tmp) 
              is_move_from_tree = 1;
    }

   if(is_move_from_tree==0)
   {
     
    int tmp;
    Move save = gl_find_move[ply];


    //int nd = (alpha+1==beta) ? depth/2 : depth-1;
    
    
    int nd = (depth/2);// | 1;

    /***
    if(alpha+1 == beta)
         if(nd > 3) nd = 3; //  -     
    ****/


    gl_find_move[ply] = 0;
    
    tmp_line[ply] = 0;
           
    tmp = Search(max(-INF, alpha-30), beta, 
           //depth/2,
           nd, //  ,      
           check,
           tmp_line, 
           1 , //isLazy
           isTree, 
           0, //useNull,  // <---- 0xA1
           
           0,
           exclude_move);

    //if(tmp >= beta && tmp > INF-100)
    //    return beta;
     
    if(gl_find_move[ply])
    {
      char buf[32];          
      vtr.in_move = gl_find_move[ply];
      //printf("-----------> d=%d, ply=%d, doNull=%d, %s\n",
      //       depth,ply,doNull,(char*)MoveToStr(vtr.in_move,buf));
    }
    gl_find_move[ply] = save;
   }
 }



//-----------------  iid ----------------------

/*****************
if(alpha+1 < beta)    // <----- 0xA1
if((vtr.isTree | vtr.hash_mv | vtr.in_move)==0)
 if(ply > 0 && depth > 5)
 {  int tmp;
    Move save = gl_find_move[ply];
    gl_find_move[ply] = 0;
    
    tmp_line[ply] = 0;
    
    tmp = Search(max(-INF, alpha-30), beta, depth/2, check,
           tmp_line, 1 , isTree, 
           0, //useNull,  // <---- 0xA1
           
           0,0);

    //if(tmp >= beta && tmp > INF-100)
    //    return beta;

    if(gl_find_move[ply])
    {
          
      vtr.in_move = gl_find_move[ply];
      //printf("-----------> d=%d, ply=%d\n",depth,ply);
    }
    gl_find_move[ply] = save;
 }
  **********/

    //cut_cnt = max(10,(treeCnt[ply+1]-treeCnt[ply])/3*2);

    while (NextMove( &vtr, &mv ))
    {
      int nextCheck = 0, nextDepth = depth - 1, cutt_off = 0;
      int add = 0, threat = 0;

      

      if(check)
      {
         MakeMove(mv);
  
      
      }else{   // prob. 
      
        if ( ( mv & ( LEFT_CASTL | RIGHT_CASTL ) ) && !LegalCastl( mv ) )
          continue;
        MakeMove( mv );
        if ( SqAttack( g.kingSq[g.xside], g.side ) )
        { // illegal move
           UnMakeMove( mv );
           continue;
        }
      }  
        
      legalCnt++;


      //0002
      if(mv==exclude_move)
      {
        UnMakeMove(mv);
        continue;
      }


      nextCheck = Check();

      // extensiens
      if ( 1 )
      {

        if ( nextCheck ){
           add += 1;
           threat = 1;
        }
        if ( PIECE( mv ) == PAWN && ( ROW( TO( mv ) ) == ( c0 == WHITE ? 1 : 6 ) ) )
        {
           add += 1;
           threat = 1;
        }
       
        if(mateThreat ){
           add += 1;
        }
		
        if(oneReply ){

            add += 1;
        }
 
        if(add > 1) add = 1;
        nextDepth  = nextDepth + add;
       }
       
       
       vtr.moveFromTree = tree_is_good(&vtr, legalCnt);


  // 0003
  // 0003 search
  // simple LMR & PVS search

  gl_find_move[ply] = 0; // clear oponent's return move

  if(legalCnt <= 3 || nextDepth <= 0)
  {

       tmp_line[ply] = 0;


       score = -Search( -beta, -alpha, nextDepth, nextCheck, tmp_line,0, vtr.moveFromTree, 
                        1,  // use null
                        0,   // in_move
                        0
                       );


  }else{
	int save = doReduction;  
	int R = legalCnt > 3 && !threat;

   // if(PLAY_STYLE!=KNOWLEDGE2)
   //  R = 0;
//x003
#ifdef MIN_KNOWLEDGE1
  if(PLAY_STYLE==KNOWLEDGE1)  // bruit force
  {
     R = 0;
     
  }
#endif
    
        doReduction = R; 
        tmp_line[ply] = 0;
        score = -Search( -(alpha+1), -alpha, nextDepth-R, nextCheck, tmp_line,
                          0,
                          vtr.moveFromTree,
                          1,
                          0,0
                       );
        doReduction = save;
 
 
 //0004
 if ( SING_IN_SEL_SEARCH  )
 {
    
   //------- sing. ext -----
    // if(0)
     //    alpha 
     //  NullMove
  if(0)
   if(R)
    if(PLAY_STYLE==KNOWLEDGE2)
     if(score <= alpha)
      if(depth > 4)
        if(!check)
          //if(gl_find_move[ply])
          {   
            int a;
            int s;

            /***
            if(PLAY_STYLE==KNOWLEDGE1)   // it is not work becowse R=0
            {
              a = INF-100;                    // check mate only :)!!?
              if(beta<=-INF+100 || alpha>=INF-100)
                a = alpha;
            }else   if(PLAY_STYLE==KNOWLEDGE3){
              a = alpha+VALUE_P/2;            // check material
              if(beta<=-INF+100 || alpha>=INF-100)
                a = alpha;
            }else
                a = alpha;                    // check all score
            ***/    
               a = alpha;




            tmp_line[ply] = 0;   //    <= alpha
                                
            s   = -Search( 
                        -(a+1),-a,
                        nextDepth/2,
                        //nextDepth-R,  
                        nextCheck, 
                        tmp_line,
                        1,   // lazy 
                        vtr.moveFromTree,
                        0,   // use null     <---------------
                        gl_find_move[ply],//in_move
                        gl_find_move[ply] // exclude_move <---------
                     );
            if(s>a) score = alpha+1;
             
          }
   //-----------------------
 }//endif       
 
 
 
      
        
        if(score > alpha) // search +1 PLY
        {
          tmp_line[ply] = 0;
          score = -Search( -beta, -alpha, nextDepth, nextCheck, tmp_line,
                          0,  //lazy
                          vtr.moveFromTree,
                          0, // use Null
                          0,0
                          );
        }
  }

skipSearch:
      UnMakeMove( mv );

      if ( is_stop_search ) return 0;

      if ( !cutt_off && score > alpha )
      {
        best_mv = mv;
        alpha = score;
        
        gl_find_move[ply] = mv;
        
        if ( TO( mv ) != TO( last ) ) killer[ply] = mv;
//        SaveHist( mv, alpha, beta );

        if ( alpha < beta || ply==0 )
        {
          SavePvLine( ret_pv_line, tmp_line, mv );
          pv_killer[ply] = mv;
        }

        //  
        if ( ply == 0 )
        {
        
# ifdef PVT
           
          pvt_push_last( &pv_table, 
                         LineCopy( (Move*)calloc( sizeof(Line)+1, 1), ret_pv_line )
                       ); 
                       
# else

          pvInsertLine(pv_tree, ret_pv_line);
                       
# endif
        

          SaveRootScore( alpha, beta, mv, depth, ret_pv_line );
		
        }
		
	   


	   
	   

        if(alpha >= beta)
          break;
        /*  
        if(ply==0)
         if(depth > 9)
          if(alpha > old_search_result[g.side])
          {
            printf("<---------- break \n");
            break;  
          }
        */  
      }
    } //while

    if ( legalCnt == 0 )
    {
      cut_forse[ply] = 5; 
    
      if ( !check ) return 0; //STALEMATE
      return -INF + ply + 1; //MATE
    }

  }//endif(1)
  
  //0002
if(best_mv)
 if(exclude_move==0) 
  if ( ply > 0 )
   if(!is_stop_search)     
    HashInsert( alpha, beta, depth, best_mv );

  if(best_mv)
//   if((best_mv & (CAPTURE|PROMOTE))==0)
    SaveHist( best_mv, alpha, beta );
  


  return alpha;
  
  
  
}//endp search




int push_passed_pawn(Move mv, int c){

  if(PIECE(mv)==PAWN)
   if(g.side==WHITE)
   {
      if(ROW(TO(mv)) <= 2)
       if( !(g.pos[TO(mv)-8] == PAWN && g.color[TO(mv)-8]==(c^1)) )
        return 1;
   }else{
      if(ROW(TO(mv)) >= 5)
       if( !(g.pos[TO(mv)+8] == PAWN && g.color[TO(mv)+8]==(c^1)) )
        return 1;
   }
   return 0;
}






//////////////  main search ///////////////

int main_search( int alpha, int beta, int depth, int check,
            Line ret_pv_line, int lazy , int isTree, int useNull,
            Move in_move
            )
{
  int Quies( int alpha, int beta );
  int StopSearch( void );
  int Evaluate( int alpha, int beta );
  int HashLook( int alpha, int beta, int depth, int * ret_score, Move * ret_mv );
  void HashInsert( int alpha, int beta, int depth, Move mv );
  int NextMove( PhaseInfo * p, Move * mv );
  int Check( void );
  void SaveHist( Move mv, int alpha, int beta );
  void SavePvLine( Line dest, Line source, Move mv );
  Move LastMove( void );
  int Repetition( void );
  int LegalCastl( Move mv );
  void SaveRootScore( int alpha, int beta, Move mv, int depth, Line line );
  int LearnLook( int depth, int alpha, int beta, int * ret_score );
  
  int score;
  Move mv = 0, best_mv = 0;
  PhaseInfo vtr;
  Line tmp_line;
  int c0 = g.side, c1 = c0 ^ 1;
  int old_alpha = alpha;
  int L_MTL = MTL(c0);
  int oneReply = 0;
  int end_search;       



  if(ply > 0)
  {

   if(check){
      int LegalMoveList(void);
      if ( LegalMoveList() == 0 ) return INF - ply; //CAP. OP. KING
      else if ( treeCnt[ply + 1] == treeCnt[ply] ) return -INF + ply + 1; // mate
      else if ( treeCnt[ply + 1] == treeCnt[ply] + 1 ) oneReply = 1;
   }else{
     /****
      if ( Generate() == 0 ) return INF - ply; //CAP. OP. KING
      else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy
     *****/
   }

  }


  if( check ){
    if(depth <= 0) depth = 1;
    
  }else if( ply > s_depth * 3 )
    depth = 0; // ??

  //0001
  PhaseInfoReset( & vtr, & alpha );
  vtr.isTree = isTree;
  vtr.in_move = in_move;// first move 

  if ( depth <= 0 ) return Quies( alpha, beta );
  if ( StopSearch() ) return 0;
  if ( ply > MAX_PLY - 4 ) return Evaluate( alpha, beta );
  if ( ply > 0 && Repetition() ){
	  if(g.side==root_side)
		  return -8; //?!! not return best move
	  return 0;
  } 
  if ( ply > 4 && //!doNull &&  // 0x000x1
      LearnLook( depth, alpha, beta, &score ) ) 
  {
      return score; // ?! not return best move
  }
  //0003
  if ( ply > 0 && HashLook( alpha, beta, depth, &score, &vtr.hash_mv ) )
  {
    //?! score not exact in main_search

    //if(!isTree) 
    //if( PLAY_STYLE == KNOWLEDGE2 )
    //   return score;
    //return score;
  }   
  
  
  if(1)    //  
  {
    int legalCnt = 0;
    int cntGoodMoves;
    Move last = LastMove();
    int mateThreat = 0;
    //int oneReply = 0;

	 
  



if(ply > 0)
{
  if(!check)
  {
    if ( Generate() == 0 ) 
       return INF - ply;           //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) 
       return 0;                   // ?? not realy
  }

}else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy



    while ( NextMove( & vtr, & mv ) )
    {
      int nextCheck = 0, nextDepth = depth - 1, cutt_off = 0;
      int add = 0, threat = 0;


      if(check)
      {
         MakeMove(mv);
  
      
      }else{   // prob. 
      
        if ( ( mv & ( LEFT_CASTL | RIGHT_CASTL ) ) && !LegalCastl( mv ) )
          continue;
        MakeMove( mv );
        if ( SqAttack( g.kingSq[g.xside], g.side ) )
        { // illegal move
           UnMakeMove( mv );
           continue;
        }
      }  
        
      legalCnt++;


      nextCheck = Check();

      // extensiens
      if ( ply > 1 )
      {

        if ( nextCheck ){
           add += 1;
           threat = 1;
        }
        if ( PIECE( mv ) == PAWN && ( ROW( TO( mv ) ) == ( c0 == WHITE ? 1 : 6 ) ) )
        {
           add += 1;
           threat = 1;
        }
       
      /****
        if(mateThreat ){
           add += 1;
        }
      *****/
		
        if(oneReply ){

            add += 1;
        }
 
        if(add > 1) add = 1;
        nextDepth  = nextDepth + add;
       }



      vtr.moveFromTree = tree_is_good(&vtr, legalCnt);

//-----------------------------

// 0003
//!!! WARNING   PUT-GET HASH SCORE WITH FOOL DEPTH
if( PLAY_STYLE == KNOWLEDGE2)
do{

   Move next_in_move = 0;   
   int nd;

   if(depth <= 0)
   {
   
          tmp_line[ply] = 0;           
          score = -Search( -beta, -alpha, 
                        nextDepth,
                        nextCheck, 
                        tmp_line,0, vtr.moveFromTree,
                        1,   // use null   // <---------
                        0,   //  next_in_move,
                        0    //  <------ exclude move
                     );
                     
          goto skipSearch;           
   }


   next_in_move = 0;   
   nd  = nextDepth;
   gl_find_move[ply] = 0;  // clear return opponent move


                               // SELECTIVE SEARCH  
  tmp_line[ply] = 0;           
          
  score = -Search( -beta, -alpha, 
                   nd,
                   nextCheck, 
                   tmp_line,0, vtr.moveFromTree,
                   1,   // use null   // <---------
                   next_in_move,
                   0    //  <------ exclude move
                );

  next_in_move = gl_find_move[ply];
     
     
  
       if(nd > 5)
        if(score <= alpha)
         //if(!check)
          if(next_in_move)
          {   
            tmp_line[ply] = 0;
            score = -Search( -(alpha+1), -alpha, 
                            //nd/2,
                            nd,
                            nextCheck, 
                            tmp_line,
                            1,  //lazy
                            vtr.moveFromTree,
                            0,   // use null     <---------------
                            0,   //next_in_move,
                            next_in_move // exclude_move <---------
                           );
          }
  




                          // MOVE IS GOOD ? (SEARCH +1 PLY)
    // if(score > alpha  &&  (score < beta || sing_extens))


     if(score > alpha)
     {
          tmp_line[ply] = 0;                  
          score = -main_search( -beta, 
                             -alpha, 
                              nextDepth, 
                              nextCheck, tmp_line,0, vtr.moveFromTree, 
                              0,
                              next_in_move  //in_move?
                            );
     }  
     
     goto skipSearch;
}while(0);
//---------------------------- end hard ------

//------------------ tmp ---------
if(PLAY_STYLE==KNOWLEDGE1)
{
   int nd;
   score = alpha+1;

//x003
   nd = max(2,nextDepth-1);
   if(nextDepth <= 2)
       nd = nextDepth;
   

   gl_find_move[ply] = 0; //clear best opponent's move 

   for(; nd <= nextDepth && 
         (score > alpha || nextCheck); 
         nd++)
   {
           tmp_line[ply] = 0;           
          
           score = -Search( -beta, -alpha, 
                        nd,
                        nextCheck, 
                        tmp_line,0, vtr.moveFromTree,
                        1,   // use null
                        gl_find_move[ply],//in_move
                        0 //exclude move
                     );
   }

   if(score > alpha || ply==1)
   {
          tmp_line[ply] = 0;                  
          score = -main_search( -beta, 
                             -alpha, 
                             nextDepth, 
                             nextCheck, tmp_line,0, vtr.moveFromTree, 
                             0,
                             gl_find_move[ply]  //in_move?
                             );
   }
    
   goto skipSearch;
}
//------------------ tmp ---------


   if(PLAY_STYLE==KNOWLEDGE1 || PLAY_STYLE==KNOWLEDGE3)    //KNOWLEDGE1 and KNOWLEDGE3
   {                             // deff. see in search(...)
    /***
       // SIMPLE SELECTIVE SEARCH
       if(selective_search(...) > alpha)
        score = main_search(...);
       else
        score \ alpha;
    ***/
    int nd;                             
    int next_in_move;

     gl_find_move[ply] = 0; //clear best opponent's move 
     next_in_move = 0;
     score = alpha+1;
     
        

     for(nd = nextDepth-1; nd <= nextDepth && (score > alpha || nextCheck); nd++)
     {
         if(!(nextCheck && nd<=0))
         {
              tmp_line[ply] = 0;           
              score = -Search( -beta, -alpha, 
                        nd,
                        nextCheck, 
                        tmp_line,0, vtr.moveFromTree,
                        1,   // use null
                        next_in_move,//in_move
                        0 //exclude move
                     );

              next_in_move = gl_find_move[ply]; // alwase, exclude nullcut,learncut,repetition 
         }
     }

     //   ,   
     //   NullCut
     if(score <= alpha)
       if(!check)
         if(depth > 5)
         {
              int a = alpha;

              tmp_line[ply] = 0;           
              score = -Search( -(a+1), -a, 
                        nextDepth/2,
                        nextCheck, 
                        tmp_line,1, vtr.moveFromTree,
                        0,   // use null
                        next_in_move,//in_move
                        next_in_move //exclude move
                     );
         }




     if(score > alpha)
     {

         /***************
         if(next_in_move)
           if(score < beta)
             if(nextDepth > 5)
               if(ply > 1)
                 if(ply <= s_depth)
                   if(depth > nextDepth)
                     if(score < INF-100)
                       if(score > -INF+100)
                           //if(vtr.moveFromTree)
                 {
                     int a = score + VALUE_P/2;
                     int tmp;

                     tmp_line[ply] = 0;           
                     tmp = -Search( -(a+1), -a, 
                          
                        nextDepth/2,
                        nextCheck, 
                        tmp_line,1, vtr.moveFromTree,
                        0,   // use null
                        0,//in_move
                        next_in_move //exclude move
                     );
                     if(tmp > a)
                     {
                         static char buf[32];
                         nextDepth = depth;
                        // printf("------> sing.ext. ply=%d %s\n",ply,MoveToStr(mv,buf)); 
                     }
                 }
                ***********/

          tmp_line[ply] = 0;                  
          score = -main_search( -beta, 
                             -alpha, 
                             nextDepth, 
                             nextCheck, tmp_line,0, vtr.moveFromTree, 
                             0,
                             next_in_move  //in_move?
                             );
     }
     goto skipSearch;
   }


   printf("#----> main_search(); unknow style\n");
   abort();


	

skipSearch:  
       
       
      UnMakeMove( mv );


      if ( is_stop_search ) return 0;


      /***
              PV,
               
           
         .     
            () 
          .  
             
            (  
          PV,     
              
             
      ***/
      if(ply==0)
      {
        int j;
        for(j=treeCnt[ply]; j < treeCnt[ply+1]; j++)
           if(tree[j]==mv)
           {
              sort_val[j] = score;
              break; 
           }

      }



      if ( !cutt_off && score > alpha )
      {
        best_mv = mv;
        alpha = score;
        if ( TO( mv ) != TO( last ) ) killer[ply] = mv;
//        SaveHist( mv, alpha, beta );

        if ( alpha < beta || ply==0 )
        {
          SavePvLine( ret_pv_line, tmp_line, mv );
          pv_killer[ply] = mv;
        }

        //    MAIN_SEARCH
        if ( ply == 0 )
        {
  
          
# ifdef PVT
           
          pvt_push_last( &pv_table, 
                         LineCopy( (Move*)calloc( sizeof(Line)+1, 1), ret_pv_line )
                       ); 
# else

          pvInsertLine(pv_tree, ret_pv_line);
                       
# endif

           


          SaveRootScore( alpha, beta, mv, depth, ret_pv_line );
		
        }
		
	   
	   
	   

        if(alpha >= beta)
          break;
        /*  
        if(ply==0)
         if(depth > 9)
          if(alpha > old_search_result[g.side])
          {
            printf("<---------- break \n");
            break;  
          }
        */  
      }
    } //while

    if ( legalCnt == 0 )
    {
      if ( !check ) return 0; //STALEMATE
      return -INF + ply + 1; //MATE
    }

  }//endif(1)
  
  
  //0003
  if ( ply > 0 )
   if(best_mv)
    if(!is_stop_search)      
   HashInsert( alpha, beta, 
               PLAY_STYLE == KNOWLEDGE2 ? depth : 1, 
               //1,
               best_mv );

  if(best_mv)
//   if((best_mv & (CAPTURE|PROMOTE))==0)
    SaveHist( best_mv, alpha, beta );



  return alpha;
}

///////////// end main search /////////////








int Quies( int alpha, int beta )
{
  int GenerateCaptures( void );
  void QSort( int low, int high );
  void Pick( int low, int high );

  if ( StopSearch() ) return 0;
  else
  {
    int score = Evaluate( alpha, beta );
    if ( score > alpha ) alpha = score;
    if ( score >= beta ) return alpha;
    else if ( ply > MAX_PLY - 4 ) return alpha;
    else if ( ply > 0 && GenerateCaptures() == 0 ) return INF - ply;
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return alpha;
    else
    {
      int sort = 0;
      int j;
      int maxCapValue = -INF;
      Move last = LastMove();
      for ( j = treeCnt[ply]; j < treeCnt[ply + 1]; j++ )
      {
        Move mv = tree[j];
        int s = 0;
        if ( mv & CAPTURE )
        {
          if ( mv & EN_PASSANT )
          {
            s += 2 * VALUE_P;
          }
          else
          {
            int cap_v = value[g.pos[TO( mv )]];
            s += cap_v - PIECE( mv );
            if ( TO( mv ) == TO( last ) ) s += VALUE_R;
            if( cap_v > maxCapValue )
              maxCapValue = cap_v;
          }
        }
        if ( mv & PROMOTE ) s += value[PIECE( mv )];
        sort_val[j] = s;
      }
      
    
      if ( treeCnt[ply + 1] - treeCnt[ply] > 20 &&
           g.mtl[g.side] - g.mtl[g.xside] + maxCapValue < alpha
          )
      {
        QSort( treeCnt[ply], treeCnt[ply + 1] - 1 );
        sort = 1;
      }
      

      for ( j = treeCnt[ply]; j < treeCnt[ply + 1]; j++ )
      {
        Move mv;
        int tmp;

        if ( !sort ) Pick( j, treeCnt[ply + 1] - 1 );
        mv = tree[j];
        MakeMove( mv );
        tmp = -Quies( -beta, -alpha );
        UnMakeMove( mv );
        if ( tmp > alpha ) alpha = tmp;
        if ( alpha >= beta ) break;
      } //for
    }
  }
  return alpha;
}





void SaveHist( Move mv, int alpha, int beta )
{
  int incH = 1;
  int *h = & history[g.side] [PIECE( mv )] [TO( mv )];
  if ( alpha < beta ) incH += 1;
  if ( alpha > INF - 100 ){
      incH += 4;
      //mate_history[g.side] [PIECE( mv )] [TO( mv )]++;
  }
  if ( *h + incH < MAX_HIST ) (*h) += incH;
  else{
    *h = MAX_HIST;
  /*********  
    int c,p,sq;
    for(c = WHITE; c <= BLACK; c++)
     for(p = PAWN; p <= KING; p++)
      for(sq = 0; sq < 64; sq++)
        history[c][p][sq] /= 2;
    (*h) += incH;
  *********/  
    
  }
}

void HistLow(void){


    int c,p,sq;

    for(c = WHITE; c <= BLACK; c++)
     for(p = PAWN; p <= KING; p++)
      for(sq = 0; sq < 64; sq++)
        history[c][p][sq] /= 2;
}

/*
    

       
     g.game_list[g.game_cnt + ply - 1]

  :

  g.empty_moves_cnt
  repetition_set

    
*/

int Repetition( void )
{
  int set_pos_cnt, ci;
  
  //0001

  if(g.empty_moves_cnt < 3)    // actual 4 moves before rep.
    return 0;                  // step be step in MakeMove
    
  if(g.empty_moves_cnt >= 100) // chess rules - 50 empty moves
    return 1;
  
  set_pos_cnt = repetition_set[g.key & (REP_SET_SIZE-1)];
  if( set_pos_cnt < 2 )
    return 0;                  // 1 - current position


  ci = g.game_cnt + ply - 1;
  if(ci <= 0) return 0;

  if ( 1 )
  {
    Move    *mv   =  &g.game_list[ci];
    HashKey *key  =  &g.key_list[ci];
    int     cnt   =  0, 
            rep = 0;
    
    
    //??
    //printf("----- key==start_pos_key %d, ci=%d \n", *key==g.key, ci);
    
    
    while ( mv >= g.game_list )
    {
      if(*key == g.key)
      {
         rep++;     
         
         
         //??
         //printf("--------> rep. cnt = %d\n", cnt);
         
         if(rep == 2)
          if(ci >= g.game_cnt - 1) 
            return 1;      // 1 rep. in search tree 
            
         if(rep == 3)
            return 1;      // chess rules
             
                      
         if(--set_pos_cnt <= 0)  
           return 0;      
      }
      
      
      if( (*mv & (CAPTURE|PROMOTE|LEFT_CASTL|RIGHT_CASTL)) || 
           *mv == 0 || 
          PIECE((*mv)) == PAWN)
        return 0;          // move change position (not back)
      
      
      
      cnt++; ci--;
      mv--; key--;
    }
  }
  
  
  
  return 0;
}


//0001
int NextMove( PhaseInfo * q, Move * ret_mv )
{
  void QSort( int low, int high );
  void Pick( int low, int high );
  void RootPick( int low, int high );
  int k, j;
  //Move last = LastMove();

  switch ( q->phase )
  {
    case 0:
      {
//        last = LastMove();
        
        q->low = treeCnt[ply];
        q->high = treeCnt[ply + 1];

        q->phase++;
        
//0003        
        if(q->in_move)
        {
          int j;
          for( j = q->low; j < q->high; j++)
          {
           if( tree[j] == q->in_move )
           {
               if( j != q->low )
               {
                 SWAP( sort_val[q->low], sort_val[j] );
                 SWAP( tree[q->low], tree[j] );
               }
               *ret_mv = tree[q->low++];
               q->moveFromTree = 1; // ??
               return 1;
           }
          }   
        }
      }




   /*************
   case 1:
   {
    q->phase++;                             // PICK PROB_PV MOVE
    if( q->isTree && doNull==0 )
    {
     int j;
     for( j = ply-1; j >= 0; j--)
      if(prob_pv[j] != g.game_list[g.game_cnt + j])
        goto not_found;
     for( j = q->low; j < q->high; j++)
     {
           if( tree[j] == q->in_move )
           {
               if( j != q->low )
               {
                 SWAP( sort_val[q->low], sort_val[j] );
                 SWAP( tree[q->low], tree[j] );
               }
               *ret_mv = tree[q->low++];
               q->moveFromTree = 1; // ??
               return 1;
           }
     }   
not_found:
     j = 0;
   }
   
   
  }//case 1 
   **************/   


   case 1:{

       if( q->isTree && (doNull /*| doReduction*/ )==0 ){
            PVNode **tmp  = pvFindNodeTree(pv_tree, &g.game_list[g.game_cnt], ply);
            if(tmp && *tmp) q->list_pv = *tmp;
       }
       q->phase++;
   }



   case 2:{

  
                                            //Pick one pv-move
      while( q->list_pv )
      {
        if ( q->low < q->high )
        {
          int j;
          for( j = q->low; j < q->high; j++)
          {
           if( tree[j] == q->list_pv->mv )
           {
               q->list_pv = q->list_pv->moves;
               if( j != q->low )
               {
                 SWAP( sort_val[q->low], sort_val[j] );
                 SWAP( tree[q->low], tree[j] );
               }
               *ret_mv = tree[q->low++];
               q->moveFromTree = 1;
               return 1;
           }
          }//for 
        }//endif
        q->list_pv = q->list_pv->moves;
      }//end while
      q->moveFromTree = 0;
      q->phase++;


      if(ply==0) // if PV_TREE then all moves end
      {
        q->phase  = 6;
        goto label_case6; // skip sort cap. and other
      }

   }//case

   case 3:{
        Move last = LastMove();

        if ( doNull == 0 )
        {
          q->pv_mv = pv_line[ply]; //? not used
        }
        q->kill_mv = killer[ply];
        q->pvkill_pv = pv_killer[ply];
        // PICK ALL CAPTURES
        for ( k = j = q->low; j < q->high; j++ )
        {
          Move mv = tree[j];
          int s = 0;
          if ( mv & CAPTURE )
          {
            if ( mv & EN_PASSANT )
            {
              s += 2 * VALUE_P;
            }
            else
            {
              //extern int max(int v1,int v2);
              s += value[g.pos[TO( mv )]] - PIECE( mv );
              //s += score_table[g.xside][g.pos[TO(mv)]] [TO(mv)];
              if ( TO( mv ) == TO( last ) ) s += VALUE_R;

            }
          }
          if ( mv & PROMOTE ) s += value[PIECE( mv )];
          //if ( mv == q->pv_mv ) s += 4 * VALUE_Q;
          if ( mv == q->hash_mv ) s += 2 * VALUE_Q;
          if ( mv == q->kill_mv ) s += 2 * VALUE_P - 10;
          if ( mv == q->pvkill_pv ) s += VALUE_P - 10;
          //if(  mv == q->pv_mv ) s += 30;


          if ( s > 0 )
          {
//            s += history[g.side][PIECE(mv)][TO(mv)];

            tree[j] = tree[k];
            tree[k] = mv;
            sort_val[k] = s;
            k++;
          }
        } //for

        q->high = k;
        q->sort = 0;
        q->phase++;
        if ( q->high - q->low > 30 )
        {
          QSort( q->low, q->high - 1 );
          q->sort = 1;
        }
      } //case 0

    case 4:
      {
        if ( q->low < q->high )
        {
          if ( q->sort == 0 ) Pick( q->low, q->high - 1 );
          * ret_mv = tree[q->low++];
          return 1;
        }
        q->phase++;

      } //case 1
    case 5: // other moves
      {
        int j;
        Move mv;
        
        q->low = q->high;
        q->high = treeCnt[ply + 1];
         
      if(g.side==BLACK)
      {   
        for ( j = q->low; j < q->high; j++ )
        {
          mv = tree[j];
          sort_val[j] = (history[g.side][PIECE(mv)][TO(mv)] << 14) +
                         ((64+TO(mv)-FROM(mv))<<6) + (63-FROM(mv));
        }
      }else{
        for ( j = q->low; j < q->high; j++ )
        {
          mv = tree[j];
          sort_val[j] = (history[g.side][PIECE(mv)][TO(mv)] << 14) +
                ( (64 + (63-TO(mv)) - (63-FROM(mv)) )<<6 ) + FROM(mv);
        }
      }  
        q->phase++;
      } //case  

    case 6:

label_case6:
      {
        if ( q->low < q->high )
        {
          Pick( q->low, q->high - 1 );
          *ret_mv = tree[q->low++];
          return 1;
        }

      } 
      q->phase++;
    }//switch
  return 0;
}


void Pick( int low, int high )
{
  int m_i = low, max = sort_val[low], j;
  for ( j = low + 1; j <= high; j++ )
    if ( sort_val[j] > max )
    {
      max = sort_val[j];
      m_i = j;
    }

  if ( m_i != low )
  {
    SWAP( sort_val[low], sort_val[m_i] );
    SWAP( tree[low], tree[m_i] );
  }
}



void SavePvLine( Line dest, Line source, Move mv )
{
  int j;

  for ( j = ply + 1; j < MAX_PLY - 4 && source[j]; j++ )
    dest[j] = source[j];

  dest[ply] = mv;
  dest[j] = 0;
}


void QSort( int low, int high )
{
  int i, j, t;

  if ( low < high )
  {
    t = sort_val[( unsigned )( low + high ) / 2];
    i = low; j = high;
    do
    {
      while ( sort_val[i] < t ) i++;
      while ( t < sort_val[j] ) j--;
      if ( i <= j )
      {
        SWAP( sort_val[i], sort_val[j] );
        SWAP( tree[i], tree[j] );
        i++; j--;
      }
    }
    while ( i < j );
    QSort( low, j );
    QSort( i, high );
  }
}


void SaveRootScore( int alpha, int beta, Move mv, int depth, Line line )
{
  void PrintSearchStatus( int ply, int score, int time, U64 nodes, Move * pv );
  int j,k;

  search_mv = mv;
  search_depth = depth;
  search_score = alpha;
  //0002

  
  
  for(j = 0; j < g.game_cnt; j++)            // save game_list + pv
    search_list[j] = g.game_list[j];
  for(k = 0; k < MAX_PLY; k++)
    if(g.game_cnt + k < MAX_GAME + MAX_PLY)
      search_list[g.game_cnt+k] = line[k];
  search_list[g.game_cnt + min(depth,10)] = 0;      
    
    
  search_start_pos_key = g.start_pos_key;  


  PrintSearchStatus( depth, alpha, (int)(curr_time - start_time), 
                     cnt_nodes, line );
}



int SweepCnt(int c){

  return g.cnt[c][QUEEN] + g.cnt[c][ROOK] + g.cnt[c][BISHOP];
}


/****************************************
  root  search 
  1.  prob book
  2.  call recurs. alpha-beta search
*****************************************/
int SearchMove( Move *ret_mv )
{
  extern char* property_get(char name[]);
  extern void HistoryInit( int clear );
  extern void TimeReset( void );
  extern int StopSearch( void );
  extern void SaveSearchResult( int score, int depth );
  extern void HashClear( void );
  extern void InitEvaluate( void );
  extern Move MoveFromLib( int treeLow, int treeHigh );

  const int MAX_DEPTH = MAX_PLY - 10;
  int d;
  int Rnd_Root_Search(Move *ret_move);
  extern unsigned TICK_COUNT(void);
   time_t start_t__ = TICK_COUNT();
  // init var.
  srand( time( 0 ) );
  
  if(is_rnd_search)//   
      return Rnd_Root_Search(ret_mv);



  set_dir(g.side);
  TimeReset();
  InitEvaluate();
  HashClear();
  set_rep();
  
  memset( killer, 0, sizeof( killer ) );
  memset( pv_killer, 0, sizeof( pv_killer ) );
  memset(pv_line,0,sizeof(Line));
  
  root_side = g.side;
  root_mtl[WHITE] = g.mtl[WHITE];
  root_mtl[BLACK] = g.mtl[BLACK];
  
  
  search_mv    = 0;
  search_score = 0;
  search_depth = 0;
  
  



  
  LegalMoveList();
  
  if (treeCnt[1] == treeCnt[0] ) 
     return 0;
  
  
  
  do{                                   // init root list 
     int j;
     void RndMovesWithLib( int treeLow, int treeHigh);

     if( pv_tree == NULL ) pv_tree = (PVTree*)malloc(sizeof(PVTree));

   //  for( j = 0; j < treeCnt[1]; j++)
   //    sort_val[j] = rand()%20;
     RndMovesWithLib( 0, treeCnt[1]-1); // moves from lib to front ?! :))


     pvReset( pv_tree );
     for( j = 0; j < treeCnt[1]; j++)
     {
 
       Pick(j, treeCnt[1]-1); 
       //MakeMove(  tree[j] );    
       pvInsertToFront(pv_tree, &pv_tree->root ,
                      pvNewNode(pv_tree, tree[j]));
       //UnMakeMove(  tree[j] );
     }
  }while(0);
  //SEARCH

  
                                        // move from book 
                                        
  if( strcmp( property_get("book move"), "auto") == 0 )
  do
  {
    Move mv;
    
    if( rand()%101  <= 50 )
      if ( ( mv = MoveFromLib( treeCnt[0], treeCnt[1] - 1 ) ) != 0 )
      {
        *ret_mv = search_mv = mv;
        return 1;
      }
  }while ( 0 );
  




//----------------------------------------
 //0001
                                     // search property get
                                     
                                     
  //if( strcmp( property_get("search tree width null move cut"),
  //            "disable")==0)
  //  search_tree_width_null_move_cut = 0;
  // else 
   
  search_tree_width_null_move_cut = g.cnt[WHITE][QUEEN] && g.cnt[BLACK][QUEEN];
  

//0023  
 // load_play_style(property_get("play style"));

 // SINGULAR_ATTACK_ACTIVE = strcmp( property_get("singular_attack_active"), "high") == 0;

  
  //??
  //printf("# ??singular attack active = %d \n",SINGULAR_ATTACK_ACTIVE);   

  
 // search_tree_width_reductions_2 = 
 //  strcmp(  property_get("search tree width reductions 2"),
 //           "auto" ) == 0;
            






//----------------------------------------------------------
  //0002

g.game_list[g.game_cnt] = 0;         // use thread of game ?!

/***
      
      
    , 
     
        

***/
if(search_start_pos_key == g.start_pos_key)//  
{

 HistoryInit( 0 ); //   

 //   
 if(g.game_cnt == LineInCnt(g.game_list, search_list))
 {
  
  //??
  /**************************
    printf("------> add old pv-line, game_cnt=%d LineInCnt=%d\n",
           g.game_cnt,
         LineInCnt(g.game_list, search_list));
    LinePrint(g.game_list);
    LinePrint(search_list);  
  **************************/
  //       
  pvInsertLine(pv_tree, &search_list[g.game_cnt]);

 }

}else{ 

   HistoryInit( 1 );   
  
}  
  
  
  
                              // iterat. deep.   ROOT_SEARCH
do{
  int score = 0;
  int a,b;
  // 002  
  for ( d = 2; d <= MAX_DEPTH && !StopSearch(); d += 1 )
  {
    int tmp;
    int a,b;


    
//
# ifdef PVT
    
//    pvt_for_each(&pv_table, LineFree);
//    pvt_clear_all(&pv_table);
    
# endif
  
    
    
    
    
    s_depth = d;
    
    //0001

    //a = max(-INF, score - VALUE_P*2);
    //b = min(INF,  score + VALUE_P*2);
    a = -INF + 100;
    b = INF - 100;
    
    score = main_search(a,                    // ROOT_SEARCH
                        b, 
                        s_depth, Check(),
                        pv_line, 0 , 1, 0,
                        
                        0 //in_move
                        );
    if(!StopSearch())
      if(score <= a)
      {
      
         score = main_search(-INF, 
                        b, 
                        s_depth, Check(),
                        pv_line, 0 , 1, 0, 0);
      
      }else if(score >= b){
      
         score = main_search(a, 
                        INF, 
                        s_depth, Check(),
                        pv_line, 0 , 1, 0, 0);
      }                 
      
      
      
      
      
      
      //0001
      
# ifdef PVT
    
   // printf("--------  debug pv lines for depth = %d -----\n", s_depth);
    
  //  pvt_print( &pv_table );
    /***
       PV     ply==0
         
          
          PV, 
        
        
      (  ,   ,
           PV
         ,   
           
       PV  
            
          PV   
        PV
    ***/
    do{
      Move *ret_pv_line;
      
      while(ret_pv_line = pvt_pop_first(&pv_table))
      {
        //LinePrint(ret_pv_line);
        
        pvInsertLine(pv_tree, ret_pv_line);

        free(ret_pv_line);  
      }
    
    }while(0);
  
    
   // printf("---------------------------------------------\n");
# endif      
      
    if(s_depth > 5)
    {
      if( score > INF - 100 ) break;
      if( score < -INF + 100 && s_depth > 6 ) break;
      if ( ( curr_time - start_time ) * 1.2 > limit_time ) break;
    }  
  }//for
  
}while(0);  

done:


  *ret_mv  = search_mv;

  if(search_mv)
    SaveSearchResult( search_score, search_depth );

  /***
  //    
  //     
  // 
  if(search_score  < INF-100)
  do{
   int d,a,b,score, max_d = search_depth;
   Move save_mv = search_mv;
   int save_score = search_score;
   void HashDepthLow(void);
   unsigned TICK_COUNT(void);
   time_t save_t = limit_time;

   a = max(-INF, search_score-VALUE_P);
   b = min(INF,  search_score+2*VALUE_P);

   printf("# other see ...\n");

   
   if(pv_tree->root)
   {
     void PickMove(Move mv, int low, int high);
     //exlude first move
      PickMove(pv_tree->root->mv,0,treeCnt[1]-1);
      treeCnt[0]++;
    
   }

   limit_time*=2;
   TimeReset(); 
   HashDepthLow();
   HistLow();

   search_depth = 0;
   for(d = 2; d <= max_d && !StopSearch(); d++)
   {
    s_depth = d;
    
    score = main_search(a,                    // ROOT_SEARCH
                        b, 
                        s_depth, Check(),
                        pv_line, 0 , 1, 0,
                        
                        search_mv //in_move
                        );
   }
   if(score > a && 
     search_depth==max_d &&
     search_score > save_score)
   {
      char buf[64];

      printf("# find other move %s \n", MoveToStr(search_mv,buf));
      *ret_mv  = search_mv;

      if(search_mv)
       SaveSearchResult( search_score, search_depth );      
   }
   printf("#total time time %02f \n", (double)(TICK_COUNT()-start_t__)/100 );

   treeCnt[0] = 0;
   limit_time = save_t;

  }while(0);
  ***/
 
//0001
/**********
  ////?????  print tree for debug
  
  do{
    FILE *f = stdout; //fopen("test", "w");
    if(f){
      fprintf(f,"-------------------\n");

      pvPrint(pv_tree->root , f);
      //fclose(f);
    }
  }while(0);
  
  /////?????
***************/  



  return search_mv != 0;
}



void HistoryInit( int clear )
{
  int c, p, sq, mid, max_val;
  unsigned cnt;
  U64 summ;



  if( clear )
  {
    memset(history,0,sizeof(history));
    return;
  }
  
  
  cnt  = 0;                            
  summ = 0;
  max_val  = 0;

  for(c=WHITE; c <= BLACK; c++)
   for(p=PAWN; p <= KING; p++)
    for(sq = 0; sq < 64; sq++)
    {
      if(history[c][p][sq] > 0)
      {
        summ += history[c][p][sq];
        cnt++;
        max_val = max( max_val, history[c][p][sq] );
      
      }
    
    }

  
  mid = max(1, summ/max(1,cnt));



//  printf("#----> mid=%d, max_val=%d \n", mid, max_val);


  for(c=WHITE; c <= BLACK; c++)
   for(p=PAWN; p <= KING; p++)
    for(sq = 0; sq < 64; sq++)
    {
      if( history[c][p][sq] > mid )
      {
        if(history[c][p][sq] > max_val/3*2)
           history[c][p][sq] = 2;
        else
           history[c][p][sq] = 1;
      
//        printf("#----->  hist point: c=%d, p=%d, sq=%s, val=%d \n",
//                c, p, chb[sq], history[c][p][sq] );      
      }
    
    }



}


